.terraform-apply:
  image:
    name: hashicorp/terraform:light
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  artifacts:
    paths:
      - "${CI_PROJECT_DIR}/.cicd/terraform"
      - "${CI_PROJECT_DIR}/.cicd/ansible/inventories"
    when: always
    expire_in: never
    reports:
      dotenv: "${CI_PROJECT_DIR}/.cicd/terraform/terraform-apply.env"
  before_script:
    # Get variables for paths and terraform
    # - export ENVIRONMENT=${CI_JOB_NAME#*-}    # Cuts job name to '-' character inclusive (Current Working Environment)
    - export KEYS_PATH=${CI_PROJECT_DIR}/.cicd/secrets/vault/${ENVIRONMENT}/ansible/secrets
    # Get ssh keys
    - mkdir -p ~/.ssh && cp ${KEYS_PATH}/* ~/.ssh/
    - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
    # Put vars for key paths to terraform.tfvars
    - cp ${CI_PROJECT_DIR}/.cicd/secrets/vault/${ENVIRONMENT}/terraform/secrets/* ${CI_PROJECT_DIR}/.cicd/terraform
    - echo "private_key_path = \"${KEYS_PATH}/id_rsa\"" >> ${CI_PROJECT_DIR}/.cicd/terraform/terraform.tfvars
    - echo "public_key_path = \"${KEYS_PATH}/id_rsa.pub\"" >> ${CI_PROJECT_DIR}/.cicd/terraform/terraform.tfvars
    # Create empty dir for ENVIRONMENT inventory (uses in terraform resourses) and put var with hosts path to terraform.tfvars
    - export HOSTS_PATH=${CI_PROJECT_DIR}/.cicd/ansible/inventories/${ENVIRONMENT}
    - mkdir -p ${HOSTS_PATH} || true
    - echo "hosts_path = \"${HOSTS_PATH}/hosts\"" >> ${CI_PROJECT_DIR}/.cicd/terraform/terraform.tfvars
    - echo "app_name = \"lms-${ENVIRONMENT}\"" >> ${CI_PROJECT_DIR}/.cicd/terraform/terraform.tfvars
  script:
    - export ZONE=${DEPLOY_DOMAIN%.*}
    - cd .cicd/terraform
    - terraform init
    - terraform plan -out "planfile"
    - terraform apply -input=false "planfile" || FAILED=true
    - |
      if [ ${FAILED} ]; then
        terraform import google_dns_managed_zone.${ZONE} ${ZONE}
        terraform plan -out "planfile"
        terraform apply -input=false "planfile"
      fi
    - cat "${CI_PROJECT_DIR}/.cicd/ansible/inventories/${ENVIRONMENT}/hosts"



    # - cd .cicd/terraform
    # - terraform init
    # - terraform plan -out "planfile" && terraform apply -input=false "planfile"
    # - cat "${CI_PROJECT_DIR}/.cicd/ansible/inventories/${ENVIRONMENT}/hosts"
    # - IP=$(terraform output vm-external-ip)
    # - echo "DEPLOY_HOST=${IP}" >> terraform-apply.env 